# Specfile for Counter-Server

%define name	ksm-counter-server
%define version	1.0.1
%define release	3.0.0
%define _arch	noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _bindir		/usr/local/bin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	A counter for webpages
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Networking/Web
Source:		%{name}.tgz
URL:		http://www.kaesman-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	samplepkg,samplecapab
Requires:	netpbm, httpd
Requires:	ksm-lib-sh >= 4.0.0-0.0.0
Provides:	webcounter
#Conflicts:	sampled-other,libsample == 0.0.0
Obsoletes:	ksm-counter

%description
This package contains counter software for webpages. 
For virtual hosts have a look into the README.

Please check/configure:
 /usr/local/etc/counter.conf
 /usr/local/etc/counter.pwd

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/sample.conf
#%config %{_confdir}/sample.conf
#%config %{_scnfdir}/sample
%{_confdir}/counter.conf

#%attr(744,root,root)/%{_rcdir}/sampleserver

%attr(700,root,root)%{_bindir}/create-counter
%attr(755,root,root)/srv/www/cgi-bin/count.cgi
%attr(755,root,root)/srv/www/cgi-bin/count.sh
%attr(644,wwwrun,www)/srv/www/htdocs/counter/counter.png

%{_datadir}/RELEASE
%{_datadir}/VERSION
%attr(600,wwwrun,www)%{_datadir}/counter.pwd.templ
%{_datadir}/counter-parts/cnt-0.pnm
%{_datadir}/counter-parts/cnt-1.pnm
%{_datadir}/counter-parts/cnt-2.pnm
%{_datadir}/counter-parts/cnt-3.pnm
%{_datadir}/counter-parts/cnt-4.pnm
%{_datadir}/counter-parts/cnt-5.pnm
%{_datadir}/counter-parts/cnt-6.pnm
%{_datadir}/counter-parts/cnt-7.pnm
%{_datadir}/counter-parts/cnt-8.pnm
%{_datadir}/counter-parts/cnt-9.pnm
%{_datadir}/counter-parts/cnt-l.pnm
%{_datadir}/counter-parts/cnt-r.pnm
%{_datadir}/counter-parts/counter.png

#/usr/share/applications/sample.desktop
#%{_icondir}/16x16/apps/sample.png
#%{_icondir}/22x22/apps/sample.png
#%{_icondir}/32x32/apps/sample.png
#%{_icondir}/48x48/apps/sample.png
#%{_icondir}/64x64/apps/sample.png
#%{_icondir}/128x128/apps/sample.png
#/usr/share/pixmaps/sample.png

#%docdir %{_man1dir}
#%{_man1dir}/sample.1.gz

%docdir %{_man8dir}
%{_man8dir}/create-counter.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
#%{_docdir}/README.de

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# disable sample and stop sampled
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1
#test -x %{_rcdir}/sampled && %{_rcdir}/sampled stop > /dev/null 2>&1

# backup config files
test -e %{_confdir}/counter.conf && cp %{_confdir}/counter.conf %{_confdir}/counter.conf.rpmsave
#test -e %{_scnfdir}/sample && cp %{_scnfdir}/sample %{_scnfdir}/sample.rpmsave

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# set config pathname and all config vars from new config file
cf=%{_confdir}/counter.conf
cnfvars='SrvDir WebDir WebUser WebGroup CntrHost'

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/sample.directory \
#	/usr/share/applications/sample.desktop \
#	/usr/share/applications/sample-admin.desktop

if [ "$1" == 1 ]; then					# install package
#	# set link
#	ln -sf %{_rcdir}/sampled %{_bindir}/rcsampled

	mkdir -p /srv/www/counter-dat
	chmod 755 /srv/www/counter-dat

	fn=%{_confdir}/counter.pwd
	if [ ! -e $fn ]; then
		cp %{_datadir}/counter.pwd.templ $fn
		chown wwwrun:www $fn
		chmod 600 $fn
		echo "Please configure $fn after creating counters."
	fi

	fn=/srv/www/counter-dat/counter.dat
	if [ ! -e $fn ]; then
		echo 0 > $fn
		chown wwwrun:www $fn
		chmod 644 $fn
	fi

#	echo "Configure $fn"
#	echo "Users must create HOME/.samplerc with update-sample"
else							# upgrade package
	# update global conf
	c=''
	s=''
	t=''
	ret=0
	if [ -e $cf.rpmsave ]; then
		#cp $cf $cf.rpmnew
		. $cf
		. $cf.rpmsave
		if [ -x %{_bindir}/replcnfvar ]; then
			for c in $cnfvars; do
				t="\$$c"
				eval s="$t"
				s=\"$s\"
				%{_bindir}/replcnfvar $cf $c "$s"
			done
		else
			echo "Error - cmd replcnfvar not found or not executable!" >&2
			echo "Conf file not updated!" >&2
		fi
		diff $cf $cf.rpmsave > /dev/null 2>&1
		ret=$?
		if [ "$ret" -eq 0 ]; then
			rm $cf.rpmsave
		else
			echo "Please check $cf"
		fi
	fi

#	echo "If new version then users must update HOME/.samplerc with update-sample"
fi
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

# disable sample and stop sampled
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1
#test -x %{_rcdir}/sampled && %{_rcdir}/sampled stop > /dev/null 2>&1

#if [ "$1" == 0 ]; then					# remove package
#	# backup config files
#	test -e %{_confdir}/sample.conf && cp %{_confdir}/sample.conf %{_confdir}/sample.conf.rpmsave
#	test -e %{_scnfdir}/sample && cp %{_scnfdir}/sample %{_scnfdir}/sample.rpmsave
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/sample

	# remove link
	#if [ -e /usr/local/bin/rcsampled ]; then
	#	rm -f /usr/local/bin/rcsampled
	#fi

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/sample.directory \
	#	/usr/share/applications/sample.desktop \
	#	/usr/share/applications/sample-admin.desktop
#else							# upgrade package
	#%{_bindir}/togglesample -e > /dev/null 2>&1
	#%{_rcdir}/sampled start > /dev/null 2>&1
fi
exit 0

%changelog
* Thu Jan 06 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.1-3.0.0
- Update to the libfuncstd-sh 4.0.0

* Mon Jan 23 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.1-2.3.0
- All scripts have been revised/improved
  (using function GetOpt).

* Thu Nov 10 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.1-2.2.0
- The script create-counter has been revised.

* Mon Jan 11 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.1-2.1.0
- Several permissions are modified.

* Mon Jan 11 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.1-2.0.0
- The scripts count.cgi and count.sh have been revised.
- Following directories have been renamed:
  /srv/www/cntr-dat    --> /srv/www/counter-dat
  /srv/www/htdocs/cntr --> /srv/www/htdocs/counter

* Thu Nov 12 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.1-1.6.1
- The docu of the package has been revised.

* Thu Nov 12 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.1-1.6.0
- The scripts count.cgi and count.sh have been revised.

* Thu Oct 08 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.1-1.5.0
- The name of an internal script has changed from
  counter.sh to count.sh

* Thu Oct 01 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.1-1.4.0
- The script counter.sh has been revised.

* Mon Aug 31 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.1-1.3.0
- The package ksm-counter-server has been revised
  (chown wwwrun:www /usr/local/etc/counter.pwd).

* Thu Jul 02 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.1-1.2.0
- The package ksm-counter-server has been revised.

* Thu Jul 02 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.1-1.1.0
- The package ksm-counter-server has been revised.

* Mon Jun 29 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.1-1.0.0
- The package ksm-counter has been splitted into the packages
  ksm-counter-server and ksm-counter-client

* Wed Oct 01 2014 Repomaster <repomaster@kaesmann-online.de> 1.0.1-0.3.4
- The docu of the package ksm-counter has been revised.

* Tue Sep 25 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.3.0
- The package has been revised.

* Thu Apr 26 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.2.0
- The config update process has been revised.

* Wed Apr 25 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.1.0
- The package has been revised.

* Wed Apr 25 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.0.0
- Now the script setcounter reads one value from global
  config file counter.conf.

* Wed Apr 25 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.2.0
- The package has been revised.

* Fri Apr 20 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.1.0
- The RPM scriptlets are revised.

* Mon Apr 02 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.0.3
- The release naming scheme has changed ('.ksm' is removed).

* Mon Jan 03 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.0.3.ksm
- The package name has changed to avoid conflicts with the openSUSE
  distribution. It has been prepended with 'ksm-'.

* Wed Jun 09 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.0.3.ksm
- The RPM scriptlets are corrected.

* Wed Jun 09 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.0.2.ksm
- The package is revised.

* Tue Feb 02 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.0.1.ksm
- Read version and dependency infos from external files.

* Wed Jan 27 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.0.0.ksm
- Added argument host to script setcounter.
- The docu has changed.

* Fri Jan 15 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.0.2.ksm
- The package name (Release) has changed.

* Thu Nov 19 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.ksm.0.1
- The RPM scriptlets are corrected.

* Mon Oct 26 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.0
- The Package management has changed to RPM.
